Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_agent.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

//import shr_apb_monitor;
import shr_apb_bfm;
import shr_apb_env;

unit shr_apb_agent_u {

   
    -- bridge or slave
    kind : shr_apb_agent_kind_t;   
    -- shadow agent or eVC
    presence : erm_active_passive_t;

    -- Back pointer to the eVC instance to which this agent is connected.
    env : shr_apb_env_u;
    -- This is the monitor that handles agent specific bus activity.
    //agent_monitor : shr_apb_agent_monitor_u is instance;
    //    keep agent_monitor.agent == me;
    //    keep agent_monitor.kind == kind;

    -- these two events are local copies of the main env events which
    -- are created for convenience.
    event clock_rise is cycle @env.clock_rise;
    event clock_fall is @env.clock_fall;
        
    -- User can extend this method to hook in a scoreboard. The user MUST NOT
    -- alter the transfer in any way.
    transfer_completed(transfer : shr_apb_trans_s) is empty;
    
    -- This event is emitted at the same time as the transfer_completed method
    -- is called.
    event transfer_complete;

}; -- unit shr_apb_agent_u


extend BRIDGE shr_apb_agent_u {
    name : shr_apb_agent_name_t;

    short_name(): string is {
        result = append(name);
    };
	 short_name_style(): vt_style is {
        result = DARK_BLUE;
    };
};

-- ACTIVE agents have BFMs
extend ACTIVE BRIDGE shr_apb_agent_u {
    !slave_number : int;
    bfm : BRIDGE shr_apb_bfm_u is instance;
        keep bfm.bridge == me;
}; -- extend ACTIVE BRIDGE shr_apb_agent_u

extend SLAVE shr_apb_agent_u {
    id : shr_apb_slave_id_t;
    short_name(): string is {
        result = append("Slave ",id);
    };
	 short_name_style(): vt_style is {
        result = DARK_RED;
    };	 
};

extend ACTIVE SLAVE shr_apb_agent_u {
    bfm : SLAVE shr_apb_bfm_u is instance;
        keep bfm.slave == me;
}; -- extend ACTIVE SLAVE shr_apb_agent_u



'>


