Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_bfm.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

//import shr_apb_monitor;
import shr_apb_agent;
import shr_apb_env;


unit shr_apb_bfm_u {
    short_name_style(): vt_style is {
      return GREEN;
    };
    logger : message_logger is instance;
      //keep logger.style ==  GREEN;
    -- Is this a BRIDGE or SLAVE
    kind : shr_apb_agent_kind_t;
    
    -- backpointer to the env this BFM is for (constrained by agent)
    env : shr_apb_env_u;
    
    -- These two events are local copies of the main env events which
    -- are created for convenience.
    event clock_rise is @env.clock_rise;
    event clock_fall is @env.clock_fall;
    
}; -- unit shr_apb_bfm_u

extend  shr_apb_bfm_u {
    smp: shr_apb_signal_map_u;
        keep smp == env.smp;	
}; 
      

extend BRIDGE shr_apb_bfm_u {
    ssmp: list of shr_apb_slave_signal_map_u;
        keep ssmp == env.ssmp;	
    -- Back pointer to the bridge agent
    bridge : ACTIVE BRIDGE shr_apb_agent_u; 
    drive_setup_phase(t : shr_apb_trans_s) @clock_rise is empty;
	 drive_enable_phase(t : shr_apb_trans_s) @clock_rise is empty;
	 drive_transfer(t : shr_apb_trans_s) @clock_rise is empty;
	 get_selnum(ad: shr_apb_address_t): uint(bits:4) is empty;
}; -- extend BRIDGE shr_apb_bfm_u

extend SLAVE shr_apb_bfm_u {
    -- Back pointer to the slave agent
    slave : ACTIVE SLAVE shr_apb_agent_u; 
    ssmp: shr_apb_slave_signal_map_u;
        keep ssmp == env.ssmp.first(.id== me.slave.id);	
    listen_and_respond() @env.clock_fall is empty;   
    //For dut slaves checking
    check_input(in : shr_apb_data_t) is empty;
    check_output(in : shr_apb_data_t, out : shr_apb_data_t) is empty;
}; -- extend SLAVE shr_apb_bfm_u

'>


