Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_bfm_bridge.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

-- Add fields to transfer struct when it is generated by a BRIDGE BFM
extend shr_apb_trans_s {

    -- delay from end of last transfer to requesting the bus for this one
    -- in clock cycles
    transmit_delay : uint;
        keep soft transmit_delay in [0..10];
        
}; -- extend  shr_apb_trans_s {
   
  
extend BRIDGE shr_apb_bfm_u {

    -- This method drives the Address Phase of a transfer
    drive_setup_phase(t : shr_apb_trans_s) @clock_rise is {
        -- Drive the address phase signals	
		bridge.slave_number = get_selnum(t.addr);
			smp.sig_pwrite$ = t.direction;
			smp.sig_paddr$ = t.addr;
			if t.direction == WRITE {
		   	smp.sig_pwdata$ = t.data;
			};
			smp.sig_penable$ = 0;	
			message(MEDIUM,"Slave selected = ",bridge.slave_number);
		if env.memory_map.get_slave_id(t.addr) != UNDEFINED {
			ssmp[bridge.slave_number].sig_psel$ = 1;
		};	
        wait cycle;
    }; -- drive_address_phase()
    
    -- This method drives the Data Phase of a transfer 
    drive_enable_phase(t : shr_apb_trans_s) @clock_rise is  {
			smp.sig_penable$ = 1;
			if bind(smp.sig_pready, external) {
				wait true(smp.sig_pready$ == 1);
			} else {
				wait cycle;
			};
			smp.sig_penable$ = 0;
			if t.direction == READ {
		   	t.data = smp.sig_prdata$;	
			};
		if env.memory_map.get_slave_id(t.addr) != UNDEFINED {
			ssmp[bridge.slave_number].sig_psel$ = 0;
		};

    }; -- drive_enable_phase()
    
    -- This method drives all phases of a transfer
    drive_transfer(t : shr_apb_trans_s) @clock_rise is {
        message(LOW, "Transfer to send: ", t);
        message(MEDIUM, "Waiting for transmit delay of ", t.transmit_delay, 
              " cycles");
        t.slave_number = env.memory_map.get_slave_id(t.addr);
		  wait [t.transmit_delay] * cycle;
        t.start();
        message(MEDIUM, "Transfer started: ", t);
        drive_setup_phase(t);
        message(MEDIUM, "Address Phase completed: ", t);
        drive_enable_phase(t);
        message(MEDIUM, "Data Phase completed: ", t);
        t.end();
    }; -- drive_transfer()

     get_selnum(ad: shr_apb_address_t): uint(bits:4) is {
        result = env.memory_map.get_slave_number(ad);
    };  
         
}; -- extend shr_apb_bfm_u {

// For PULL_MODE
extend  BRIDGE shr_apb_bfm_u {
	run() is also {
		start execute_transfers();
	};
	
	execute_transfers()@clock_rise is {
		while TRUE {
			var trans := bridge.bridge_sequence_driver.get_next_item();
			drive_transfer(trans);
			emit bridge.bridge_sequence_driver.item_done;
		};
	};
};

'>

