Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_bfm_slave.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

extend SLAVE shr_apb_bfm_u {

    !return_value : shr_apb_data_t;
	 !err 			: bool;
    //run
    run() is also {
        start listen_and_respond();
    };
	 
    listen_and_respond() @env.clock_fall is {
    
	 	  var reply_delay : uint;
			
	     while (TRUE) {
      		if bind(smp.sig_pready, external) {
					smp.sig_pready$ = 1;
				};
            wait true (ssmp.sig_psel$ == 1 and smp.sig_penable$ ==1 );
            gen reply_delay keeping {
					it in [0..4];
				};
      		if bind(smp.sig_pready, external) {
					smp.sig_pready$ = 0;
					wait [reply_delay];
					smp.sig_pready$ = 1;
				};
				gen err;
				if err {
					if bind(smp.sig_pslverr, external) {
						smp.sig_pslverr$ = 1;
					};
				};
				if smp.sig_pwrite$ == WRITE {
                get_data()
            }
            else {
                put_data();
            };
            wait cycle;
				if bind(smp.sig_pslverr, external) {
					smp.sig_pslverr$ = 0;
				};
				
				
        };
    };

    //extend those 2 functions if you want to proceed a special behaviour of the slave
    get_data() is {
        message(LOW,append("Slave ",slave.id, " received:",smp.sig_pwdata$, " for write"));
        check_input(smp.sig_pwdata$);
    };
    
    put_data() is {
         gen return_value;
         smp.sig_prdata$ = return_value;
		 message(LOW,append("Slave ",slave.id, " sends:",return_value, " for read"));
         check_output(smp.sig_prdata$, smp.sig_prdata$);
    };          

      
}; -- extend SLAVE shr_apb_bfm_u {

'>

