Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_sequence.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

-- create a generic APB sequence
sequence shr_apb_sequence using 
    item = shr_apb_trans_s,
    created_driver = shr_apb_driver_u;

-- Hook up the driver to the  BFM
extend shr_apb_driver_u {

    -- Back pointer to the BFM this driver is for
    bridge_bfm : BRIDGE shr_apb_bfm_u;
 
    -- Hook up clock
    event clock is only @bridge_bfm.clock_rise;
    
}; -- extend shr_apb_driver_u

-- Instantiate the driver in the bridge
extend ACTIVE BRIDGE shr_apb_agent_u {

    bridge_sequence_driver: shr_apb_driver_u is instance;
        keep bridge_sequence_driver.bridge_bfm == bfm;
    
}; -- extend ACTIVE BRIDGE shr_apb_agent_u

-- Create utility field and methods for basic sequences
extend shr_apb_sequence {

    -- For "do trans"
    !trans: shr_apb_trans_s;

    -- write one transfer to the bus
    write(addr : shr_apb_address_t, 
          data : shr_apb_data_t) @driver.clock is {
	  
        do trans keeping {
            .addr == addr;
            .direction == WRITE;
            .data == data };
    }; -- write()

    -- read one transfer from the bus
    read(addr : shr_apb_address_t) : shr_apb_data_t @driver.clock is {
        do trans keeping {
            .addr == addr;
            .direction == READ};
        if trans != NULL {
            result = trans.data;
        } else {
            out("trans is NULL");
        };
    }; -- read()
    
}; -- extend shr_apb_sequence





'>

