Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_signal_map.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------
<'

unit shr_apb_signal_map_u {
    name: shr_apb_bus_name_t;
    APB_PCLK: 		string;                 // clock
    APB_PRESETn: 	string;                 // reset (active low)
    APB_PADDR: 	string;                 // 32-bit address bus
    APB_PENABLE:	string;					// enable
    APB_PWDATA: 	string;                 // 32-bit write data bus
    APB_PRDATA: 	string;                 // read data bus
    APB_PWRITE: 	string;                 // transfer direction
	 APB_PREADY:	string;
	 APB_PSLVERR:	string;
};

unit shr_apb_slave_signal_map_u {
    name: shr_apb_bus_name_t;
    id: shr_apb_slave_id_t;
    APB_PSEL: 		string;     
};

extend shr_apb_signal_map_u {
   amba3 			: bool;
	sig_pclk 		: inout simple_port of bit                                is instance; 
   sig_presetn 	: inout simple_port of bit                                is instance; 
   sig_paddr		: inout simple_port of uint(bits:32)      					 is instance; 
   sig_penable 	: inout simple_port of bit                                is instance; 
   sig_pwdata 		: inout simple_port of uint(bits:32)   					    is instance; 
   sig_prdata 		: inout simple_port of uint(bits:32)   					    is instance; 
   sig_pwrite	 	: inout simple_port of shr_apb_direction_t                is instance; 
   sig_pready	 	: inout simple_port of bit                                is instance; 
   sig_pslverr	 	: inout simple_port of bit                                is instance; 

	keep bind(  sig_pclk 	,external);
	keep bind(  sig_presetn ,external);
	keep bind(  sig_paddr	,external);
	keep bind(  sig_penable ,external);
	keep bind(  sig_pwdata  ,external);
	keep bind(  sig_prdata  ,external);
	keep bind(  sig_pwrite  ,external);
	keep bind(  sig_pready  ,empty);
	keep bind(  sig_pslverr ,empty);
	
	when amba3 shr_apb_signal_map_u {
		keep bind(  sig_pready  ,external);
		keep bind(  sig_pslverr ,external);
	};
	
	
	keep soft  sig_pclk.hdl_path() == APB_PCLK;
	keep soft  sig_presetn.hdl_path() == APB_PRESETn; 
	keep soft  sig_paddr.hdl_path() == APB_PADDR; 
	keep soft  sig_penable.hdl_path() == APB_PENABLE;
	keep soft  sig_pwdata.hdl_path() ==  APB_PWDATA; 
	keep soft  sig_prdata.hdl_path() ==  APB_PRDATA; 
	keep soft  sig_pwrite.hdl_path() ==  APB_PWRITE; 
	keep soft  sig_pready.hdl_path() ==  APB_PREADY;
	keep soft  sig_pslverr.hdl_path() == APB_PSLVERR;
	
};

extend shr_apb_slave_signal_map_u {
	sig_psel	 		: inout simple_port of bit   is instance; 
	keep soft sig_psel.hdl_path() == APB_PSEL;
	keep bind(sig_psel ,external);
};

'>


