Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_trans.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

-- This type is used to sub-type the transfer struct. By default the transfer
-- is a generic transfer, but other code can extend this type to create 
-- sub-types that can have extra fields etc for special purposes 

struct shr_apb_trans_s like any_sequence_item {
    start : time;
    end : time;    
    start() is {
      start = sys.time;
    };
    end() is {
      end = sys.time;
    };
    
    addr : shr_apb_address_t;
	 !slave_number : shr_apb_slave_id_t; 
	 	// This field will be updated by the driver or the monitor
		
    -- Is this a read or write transfer
    direction : shr_apb_direction_t;
        keep direction in [READ, WRITE];
	 !err : bool;
    -- Data is the list of bytes to be transferred - size of list depends on
    -- transfer size.
    data : shr_apb_data_t;
    
    -- create a "nice" means of displaying a transfer
    nice_string(): string is only {
        if direction == WRITE {
            result = append(direction, 
                        "(at ", 
                        addr,
                        ",{",
                        data,
                        "})");
        } else {
            result = append(direction, 
                        "(at ", 
                        addr,
                        ")");
        };

    }; -- nice_string()
}; -- struct shr_apb_trans_s

'>

