Title        : Top level env unit for eVC
Project      : APB eVC
File name    : examples/test_3.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

-- import the eVC configuration file (which in turn imports the APB eVC)
import shr_apb/examples/shr_apb_config;


extend sys {
    setup() is also {
        -- Turn on coverage
        set_config(cover, mode, normal);
    };
}; -- extend sys

extend shr_apb_sequence_kind : [READ_WRITE, INTERRUPT, READ, WRITE, STRESS, LARGE];

extend READ_WRITE shr_apb_sequence {
    count : uint[1..5];
    keep count == 5;

    body()@driver.clock is only {
        for i from 0 to count {
            do trans keeping {
                .direction == (odd(i) ? WRITE : READ);
            };
        };
    };
};

extend READ shr_apb_sequence {
    count : uint[1..5];
    keep trans.direction == READ;
    keep count == 5;
    body()@driver.clock is only {
        for i from 0 to count {
            do trans keeping {
                .direction == READ;
            };
        };
    };
};

extend WRITE shr_apb_sequence {
    count : uint[1..5];
    keep trans.direction == WRITE;
    keep count == 5;
    body()@driver.clock is only {
        for i from 0 to count {
            do trans keeping {
                .direction == WRITE;
            };
        };
    };
};

extend shr_apb_env_u {
	keep log_enable == TRUE;
};

'>
// Interrupt handler
extend INTERRUPT shr_apb_sequence {
    body()@driver.clock is only {
      while (TRUE) {
        sync @driver.interrupt;
        grab(driver);
        //driver.sequence.stop();
        do trans keeping {.data == 0xffffffff; .direction == WRITE; .transmit_delay==0};
        do trans keeping {.data == 0x01010101; .direction == WRITE; .transmit_delay==0};
        do trans keeping {.data == 0x00000000; .direction == WRITE; .transmit_delay==0};
        ungrab(driver);
      };
     };
};
    
    
	
	
extend shr_apb_driver_u {
  iseq  : INTERRUPT shr_apb_sequence;
  event interrupt is change('~/top/irq')@sim;
  keep iseq.driver == me;
  run() is also {
    iseq.start();
  };
};    

	
extend sys {
  irq : irq_driver_u is instance;
};

unit irq_driver_u {
  event clk is change('~/top/clock')@sim;
  my_tcm()@clk is {
    wait [30];
    '~/top/irq'  = 1;
    wait [12];
    '~/top/irq'  = 0;
  };
  run() is also {
    start my_tcm();
  };
};

// End of Interrupt implementation
<'

extend shr_apb_trans_s {
    keep in_sequence(STRESS shr_apb_sequence) => transmit_delay < 2;
    keep in_sequence(LARGE shr_apb_sequence) => transmit_delay > 10;
};

extend MAIN shr_apb_sequence {
    !read_seq : READ shr_apb_sequence;
    !write_seq : WRITE shr_apb_sequence;
    !rw_seq : READ_WRITE shr_apb_sequence;
    !random_seq : shr_apb_sequence;
    keep count == 5;

    body()@driver.clock is only {                   
        do write_seq;
        do read_seq;
        do rw_seq;
        do random_seq ;
        do random_seq ;
    };
};


'>

